package cn.com.qmth.stmms.ms.admin.utils;

import cn.com.qmth.stmms.ms.core.domain.enums.BuiltInAccountEnum;
import cn.com.qmth.stmms.ms.core.domain.user.MarkUser;
import cn.com.qmth.stmms.ms.core.domain.user.Role;
import cn.com.qmth.stmms.ms.core.repository.MarkUserRepo;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

@Component
public class BultInAccountUtil {

    @Autowired
    MarkUserRepo markUserRepo;

    public void createAccout() {
        List<MarkUser> userList = new ArrayList<>();
        List<Map> mapList = BuiltInAccountEnum.listAccounts();
        if (mapList.size() > 0) {
            for (Map map : mapList) {
                //采集账号
                if (Objects.equals(BuiltInAccountEnum.SCAN.name(), map.get("type").toString())) {
                    for (int i = 1; i <= 10; i++) {
                        String loginName = map.get("code").toString().toLowerCase() + lpad(2, i);
                        MarkUser markUser = markUserRepo.findByLoginName(loginName);
                        if (markUser != null) {
                            continue;
                        }
                        markUser = new MarkUser(loginName, "123456", 0L, Subject.SC, loginName, Role.findByName((String) map.get("name")), null);
                        userList.add(markUser);
                    }
                } else {
                    String loginName = map.get("code").toString().toLowerCase();
                    MarkUser markUser = markUserRepo.findByLoginName(loginName.toLowerCase());
                    if (markUser != null) {
                        continue;
                    }
                    markUser = new MarkUser(loginName, "123456", 0L, Subject.SC, loginName, Role.findByName((String) map.get("name")), null);
                    userList.add(markUser);
                }
            }
            markUserRepo.save(userList);
        }
    }


    /**
     * 补齐不足长度
     *
     * @param length 长度
     * @param number 数字
     * @return
     */
    private static String lpad(int length, int number) {
        String f = "%0" + length + "d";
        return String.format(f, number);
    }
}
